<!DOCTYPE html>
<html lang="en">
  <head>
    <title>A small introduction to three.js webgl [1]</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0">
    <link rel="stylesheet" href="css/basic.css">
  
    <script src="three.js"></script>
    <script src="js/Detector.js"></script>
    <script type="text/javascript">
      
      // Checks that your browser supports WebGL. 
      if ( ! Detector.webgl ) Detector.addGetWebGLMessage();
      
      var renderer = null; 
      var scene    = null;
      var camera   = null;
      var cube     = null;
      var sphere   = null;
      var curTime  = Date.now();
      
      // This function is called whenever the document is loaded
      function init() {
		// Get display canvas
		var canvas = document.getElementById("webglcanvas");
		console.log( canvas );

		// Create the Three.js renderer and attach it to our canvas
		renderer = new THREE.WebGLRenderer( { canvas: canvas,
						antialias: true } );
		// Set the viewport size
		renderer.setSize( canvas.width, canvas.height );
		// Create a new Three.js scene
		scene = new THREE.Scene();
		// Add  a camera so we can view the scene
		camera = new THREE.PerspectiveCamera( 45, canvas.width / canvas.height,
						1, 4000 );
		// Create a texture-mapped cube and add it to the scene
		// First, create the texture map
		var mapUrl = "images/webgl-logo-256.jpg";
		var map    = new THREE.TextureLoader().load( mapUrl );

		// Now, create a Basic material; pass in the map
		var material = new THREE.MeshBasicMaterial({ map: map });

		// Create the cube geometry
		var geometry = new THREE.BoxGeometry(2, 2, 2);

		// And put the geometry and material together into a mesh
		cube = new THREE.Mesh(geometry, material);

		// Move the mesh back from the camera and tilt it toward the viewer
		cube.position.z = -8;
		cube.rotation.x = Math.PI / 5;
		cube.rotation.y = Math.PI / 5;

		// Finally, add the mesh to our scene
		//scene.add( cube );

		//Question 2.1 Ajout d'une shpère
		//Texture
		var mapSphere = new THREE.TextureLoader().load( "images/earth_atmos_2048.jpg" );

		//Material
		//Q.2.1
		//var materialSphere = new THREE.MeshBasicMaterial({ map: mapSphere });
		var materialSphere = new THREE.MeshPhongMaterial({color: 0x7777ff});

		//Geometry
		var geometrySphere = new THREE.SphereGeometry(1, 50, 50);

		//Put the geometry and material together into a mesh
		sphere = new THREE.Mesh(geometrySphere, materialSphere);

		// Move the mesh back from the camera and tilt it toward the viewer
		sphere.position.z = -3;
		sphere.rotation.x = Math.PI / 5;
		sphere.rotation.y = Math.PI / 5;

		//Add sphere to the scene
		scene.add(sphere);

		// Add a white point light
		
		light = new THREE.PointLight( 0xffffff, 1.5);
		light.position.set(50,50,50);
		scene.add( light );
      }
      
      // This function is called regularly to update the canvas webgl.
      function run() {
		  // Ask to call again run 
		  requestAnimationFrame( run );
		  
		  // Render the scene
		  render();
		  
		  // Calls the animate function if objects or camera should move
		  animate();
      }
      
      // This function is called regularly to take care of the rendering.
      function render() {
		  // Render the scene
		  renderer.render( scene, camera );
      }
      
      // This function is called regularly to update objects.
      function animate() {
		  // Computes how time has changed since last display
		  var now       = Date.now();
		  var deltaTime = now - curTime;
		  curTime       = now;
		  var fracTime  = deltaTime / 1000; // in seconds
		  // Now we can move objects, camera, etc.
		  // Example: rotation cube
		  var angle = 0.1 * Math.PI * 2 * fracTime; // one turn per 10 second.
		  cube.rotation.y += angle;
      }
      
    </script>
  </head>
  <body>
    <div id="info"> a first three.js example </div>
    <canvas id="webglcanvas" style="border: none;background-color:#000000"
	    width="600" height="500"></canvas>
    <!-- We run the WebGL code at the end to be sure that the document is loaded.
      -->
    <script>
      init(); run();
    </script> 
  </body>
</html>

